#include <vector>
#include <iostream>
#include <rsb.h>

auto render_test() -> int
{
	rsb_mtx_t *mtxAp {};
	rsb_coo_idx_t pmWidth {512}, pmHeight {512};
	std::vector<rsb_coo_idx_t> IA{0}, JA{0};
	std::vector<double> VA{1.};
	rsb_marf_t rflags {RSB_MARF_EPS};
	rsb_err_t errval {RSB_ERR_NO_ERROR};
	rsb_nnz_idx_t nnzA = VA.size();
	rsb_type_t typecode {RSB_NUMERICAL_TYPE_DOUBLE};
	rsb_coo_idx_t nrA {1}, ncA{1}, brA{1}, bcA{1};
       	rsb_flags_t flagsA{RSB_FLAG_NOFLAGS};

	if( (errval = rsb_lib_init(RSB_NULL_INIT_OPTIONS)) != RSB_ERR_NO_ERROR )
		throw;

	mtxAp = rsb_mtx_alloc_from_coo_const(VA.data(), IA.data(), JA.data(), nnzA, typecode, nrA, ncA, brA, bcA, flagsA, &errval);

	if ( !mtxAp )
		throw;

	errval = rsb_mtx_rndr("file.eps", mtxAp, pmWidth, pmHeight, rflags);
	if ( errval != RSB_ERR_NO_ERROR )
		throw;

	errval = rsb_file_mtx_save(mtxAp, nullptr);
	if ( errval != RSB_ERR_NO_ERROR )
		throw;

	rsb_mtx_free(mtxAp);

	errval = rsb_lib_exit(RSB_NULL_INIT_OPTIONS);
	if ( errval != RSB_ERR_NO_ERROR )
		throw;

	std::cout << "OK" << std::endl;

	return 0;
}

auto main(const int argc, char * argv[]) -> int
{
	render_test();
}
